unit uDropFi;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ShellApi, StdCtrls;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { manipulador para mensagem da operao de drag-and-drop
      de arquivos }
    procedure WMDropFiles(var Msg: TMessage); message wm_DropFiles;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.WMDropFiles(var Msg: TMessage);
var
  I, FileCount, BufferSize: word;
  Drop: HDROP;
  FileName: string;
  Pt: TPoint;
  RctListBox, RctMemo: TRect;
begin
  { Pega o manipulador (handle) da operao
    "arrastar e soltar" (drag-and-drop) }
  Drop := Msg.wParam;

  { Pega a quantidade de arquivos soltos (dropped) }
  FileCount := DragQueryFile(Drop, $FFFFFFFF, nil, 0);

  { Se nenhum arquivo... }
  if FileCount = 0 then begin
    ShowMessage('Nenhum arquivo.');
    Exit;
  end;

  { Pega o retngulo do ListBox }
  RctListBox := ListBox1.BoundsRect;

  { Pega o retngulo do Memo }
  RctMemo := Memo1.BoundsRect;

  { Se soltou fora da rea cliente do form... }
  if not DragQueryPoint(Drop, Pt) then
    ShowMessage('Arquivos soltos fora da rea cliente do form')
  { Se soltou na rea do ListBox... }
  else if PtInRect(RctListBox, Pt) then begin
    { Pega todos os nomes de arquivos e coloca no ListBox }
    for I := 0 to FileCount -1 do begin
      { Obtm o comprimento necessrio para o nome do arquivo,
        sem contar o caractere nulo do fim da string. }
      BufferSize := DragQueryFile(Drop, I, nil, 0);
      SetLength(FileName, BufferSize +1); { O +1  p/ nulo do fim da string }
      if DragQueryFile(Drop, I, PChar(FileName), BufferSize+1) = BufferSize then
        ListBox1.Items.Add(string(PChar(FileName)))
      else
        ShowMessage('Erro ao obter nome do arquivo.');
    end;
  { Se soltou na rea do Memo... }
  end else if PtInRect(RctMemo, Pt) then begin
    if FileCount > 1 then
      ShowMessage('Ser mostrado apenas o contedo do primeiro arquivo.');

    { Obtm o comprimento necessrio para o nome do arquivo,
      sem contar o caractere nulo do fim da string.
      O segundo parmetro (zero) indica o primeiro arquivo da lista }
    BufferSize := DragQueryFile(Drop, 0, nil, 0);
    SetLength(FileName, BufferSize +1); { O +1  p/ nulo do fim da string }
    if DragQueryFile(Drop, 0, PChar(FileName), BufferSize+1) = BufferSize then
      Memo1.Lines.LoadFromFile(string(PChar(FileName)))
    else
      ShowMessage('Erro ao obter nome do arquivo.');
  end;

  Msg.Result := 0;
  inherited;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  DragAcceptFiles(Handle, true);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  DragAcceptFiles(Handle, false);
end;

end.
